Values are mapped into Cells using either field or valueGetter from the Column Definition.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ClientSideRowModelModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ headerName: "Name (field)", field: "name" },
// Using dot notation to access nested property
{ headerName: "Country (field & dot notation)", field: "person.country" },
// Show default header name
{
headerName: "Total Medals (valueGetter)",
valueGetter: (p) =>
p.data.medals.gold + p.data.medals.silver + p.data.medals.bronze,
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={{ height: "100%", boxSizing: "border-box" }}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export function getData(): any[] {
const rowData = [
{
name: 'Michael Phelps',
person: {
age: 23,
country: 'United States',
},
medals: {
gold: 8,
silver: 0,
bronze: 0,
},
},
{
name: 'Michael Phelps',
person: {
age: 19,
country: 'United States',
},
medals: {
gold: 6,
silver: 0,
bronze: 2,
},
},
{
name: 'Michael Phelps',
person: {
age: 27,
country: 'United States',
},
medals: {
gold: 4,
silver: 2,
bronze: 0,
},
},
{
name: 'Natalie Coughlin',
person: {
age: 25,
country: 'United States',
},
medals: {
gold: 1,
silver: 2,
bronze: 3,
},
},
{
name: 'Aleksey Nemov',
person: {
age: 24,
country: 'Russia',
},
medals: {
gold: 2,
silver: 1,
bronze: 3,
},
},
{
name: 'Alicia Coutts',
person: {
age: 24,
country: 'Australia',
},
medals: {
gold: 1,
silver: 3,
bronze: 1,
},
},
{
name: 'Missy Franklin',
person: {
age: 17,
country: 'United States',
},
medals: {
gold: 4,
silver: 0,
bronze: 1,
},
},
{
name: 'Ryan Lochte',
person: {
age: 27,
country: 'United States',
},
medals: {
gold: 2,
silver: 2,
bronze: 1,
},
},
{
name: 'Allison Schmitt',
person: {
age: 22,
country: 'United States',
},
medals: {
gold: 3,
silver: 1,
bronze: 1,
},
},
{
name: 'Natalie Coughlin',
person: {
age: 21,
country: 'United States',
},
medals: {
gold: 2,
silver: 2,
bronze: 1,
},
},
{
name: 'Ian Thorpe',
person: {
age: 17,
country: 'Australia',
},
medals: {
gold: 3,
silver: 2,
bronze: 0,
},
},
{
name: 'Dara Torres',
person: {
age: 33,
country: 'United States',
},
medals: {
gold: 2,
silver: 0,
bronze: 3,
},
},
{
name: 'Cindy Klassen',
person: {
age: 26,
country: 'Canada',
},
medals: {
gold: 1,
silver: 2,
bronze: 2,
},
},
{
name: 'Nastia Liukin',
person: {
age: 18,
country: 'United States',
},
medals: {
gold: 1,
silver: 3,
bronze: 1,
},
},
{
name: 'Marit Bjørgen',
person: {
age: 29,
country: 'Norway',
},
medals: {
gold: 3,
silver: 1,
bronze: 1,
},
},
{
name: 'Sun Yang',
person: {
age: 20,
country: 'China',
},
medals: {
gold: 2,
silver: 1,
bronze: 1,
},
},
{
name: 'Kirsty Coventry',
person: {
age: 24,
country: 'Zimbabwe',
},
medals: {
gold: 1,
silver: 3,
bronze: 0,
},
},
{
name: 'Libby Lenton-Trickett',
person: {
age: 23,
country: 'Australia',
},
medals: {
gold: 2,
silver: 1,
bronze: 1,
},
},
{
name: 'Ryan Lochte',
person: {
age: 24,
country: 'United States',
},
medals: {
gold: 2,
silver: 0,
bronze: 2,
},
},
{
name: 'Inge de Bruijn',
person: {
age: 30,
country: 'Netherlands',
},
medals: {
gold: 1,
silver: 1,
bronze: 2,
},
},
];
return rowData;
}
Field Copy Link
The Column Definition field property maps values from the row data object to the Column's Cells.
The field supports dot notation (e.g. medals.gold) to access properties of complex objects.
const [rowData, setRowData] = useState([
{
athlete: 'Michael Phelps',
medals: {
gold: 8, silver: 1, bronze: 0
}
}
]);
const [columnDefs, setColumnDefs] = useState([
// simple field attribute
{ field: 'athlete' },
// using dot notation, a Header Name is usually needed
{ field: 'medals.gold', headerName: 'Gold' },
]);
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
/> Value Getter Copy Link
A Value Getter is a function that gets called for each row to return the Cell Value for a Column. Typically column cell values are loaded using a field, and then a valueGetter is used when retrieving the value requires custom logic. Columns with Value Getters usually have manually provided Header Names as the grid cannot derive Header Names from Value Getters like it does with Fields.
As with other value callbacks, params.data may be undefined for group rows or rows whose data has not loaded, so a Value Getter that reads from data should handle this case. See TypeScript Generics for how typing callback params surfaces nullable values at compile time.
const [columnDefs, setColumnDefs] = useState([
// achieves the same as using 'athlete' for the field
{ headerName: 'Athlete', valueGetter: p => p.data.athlete },
// using valueGetter to combine 3 values into 1
{ headerName: 'Total Medals', valueGetter: p => p.data.bronze + p.data.silver + p.data.gold }
]);
<AgGridReact columnDefs={columnDefs} />Function or expression. Gets the value from your data for display. |
All valueGetters must be pure functions. That means, given the same state of your data, it should consistently return the same result. This is important as the grid will only call your valueGetter once during a redraw, even though the value may be used multiple times. For example, the value will be used to display the cell value, however it can additionally be used to provide values to an aggregation function when grouping.
The example below demonstrates valueGetter. The following can be noted from the demo:
Columns A and B are simple columns using
fieldValue Getters are used in all subsequent columns as follows:
- Column 'ID #' prints the row number, taken from the Row Node.
- Column 'A+B' adds A and B.
- Column 'A * 1000' multiplies A by 1000.
- Column 'B * 137' multiplies B by 137.
- Column 'Chain' takes the value 'A+B' and works on it further, thus chaining value getters.
- Column 'Const' returns back the same value for each column.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
ValueGetterParams,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ClientSideRowModelModule];
function hashValueGetter(params: ValueGetterParams) {
return params.node ? Number(params.node.id) : null;
}
function abValueGetter(params: ValueGetterParams) {
return params.data.a + params.data.b;
}
function a1000ValueGetter(params: ValueGetterParams) {
return params.data.a * 1000;
}
function b137ValueGetter(params: ValueGetterParams) {
return params.data.b * 137;
}
function chainValueGetter(params: ValueGetterParams) {
return params.getValue("aPlusB") * 1000;
}
function constValueGetter() {
return 99999;
}
function createRowData() {
const rowData = [];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(i % 4),
b: Math.floor(i % 7),
});
}
return rowData;
}
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(createRowData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
headerName: "ID #",
maxWidth: 100,
valueGetter: hashValueGetter,
},
{ field: "a" },
{ field: "b" },
{
headerName: "A + B",
colId: "aPlusB",
valueGetter: abValueGetter,
},
{
headerName: "A * 1000",
minWidth: 95,
valueGetter: a1000ValueGetter,
},
{
headerName: "B * 137",
minWidth: 90,
valueGetter: b137ValueGetter,
},
{
headerName: "Chain",
valueGetter: chainValueGetter,
},
{
headerName: "Const",
minWidth: 85,
valueGetter: constValueGetter,
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 75,
// cellClass: 'number-cell'
};
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.number-cell {
text-align: right;
}
Header Value Getters Copy Link
See the Column Header Value Getters for an example of using headerValueGetter.

Values are mapped into Cells using either field or valueGetter from the Column Definition.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="height: 100%; box-sizing: border-box">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ headerName: "Name (field)", field: "name" },
// Using dot notation to access nested property
{ headerName: "Country (field & dot notation)", field: "person.country" },
// Show default header name
{
headerName: "Total Medals (valueGetter)",
valueGetter: (p) =>
p.data.medals.gold + p.data.medals.silver + p.data.medals.bronze,
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const rowData = ref<any[] | null>(getData());
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
export function getData(): any[] {
const rowData = [
{
name: 'Michael Phelps',
person: {
age: 23,
country: 'United States',
},
medals: {
gold: 8,
silver: 0,
bronze: 0,
},
},
{
name: 'Michael Phelps',
person: {
age: 19,
country: 'United States',
},
medals: {
gold: 6,
silver: 0,
bronze: 2,
},
},
{
name: 'Michael Phelps',
person: {
age: 27,
country: 'United States',
},
medals: {
gold: 4,
silver: 2,
bronze: 0,
},
},
{
name: 'Natalie Coughlin',
person: {
age: 25,
country: 'United States',
},
medals: {
gold: 1,
silver: 2,
bronze: 3,
},
},
{
name: 'Aleksey Nemov',
person: {
age: 24,
country: 'Russia',
},
medals: {
gold: 2,
silver: 1,
bronze: 3,
},
},
{
name: 'Alicia Coutts',
person: {
age: 24,
country: 'Australia',
},
medals: {
gold: 1,
silver: 3,
bronze: 1,
},
},
{
name: 'Missy Franklin',
person: {
age: 17,
country: 'United States',
},
medals: {
gold: 4,
silver: 0,
bronze: 1,
},
},
{
name: 'Ryan Lochte',
person: {
age: 27,
country: 'United States',
},
medals: {
gold: 2,
silver: 2,
bronze: 1,
},
},
{
name: 'Allison Schmitt',
person: {
age: 22,
country: 'United States',
},
medals: {
gold: 3,
silver: 1,
bronze: 1,
},
},
{
name: 'Natalie Coughlin',
person: {
age: 21,
country: 'United States',
},
medals: {
gold: 2,
silver: 2,
bronze: 1,
},
},
{
name: 'Ian Thorpe',
person: {
age: 17,
country: 'Australia',
},
medals: {
gold: 3,
silver: 2,
bronze: 0,
},
},
{
name: 'Dara Torres',
person: {
age: 33,
country: 'United States',
},
medals: {
gold: 2,
silver: 0,
bronze: 3,
},
},
{
name: 'Cindy Klassen',
person: {
age: 26,
country: 'Canada',
},
medals: {
gold: 1,
silver: 2,
bronze: 2,
},
},
{
name: 'Nastia Liukin',
person: {
age: 18,
country: 'United States',
},
medals: {
gold: 1,
silver: 3,
bronze: 1,
},
},
{
name: 'Marit Bjørgen',
person: {
age: 29,
country: 'Norway',
},
medals: {
gold: 3,
silver: 1,
bronze: 1,
},
},
{
name: 'Sun Yang',
person: {
age: 20,
country: 'China',
},
medals: {
gold: 2,
silver: 1,
bronze: 1,
},
},
{
name: 'Kirsty Coventry',
person: {
age: 24,
country: 'Zimbabwe',
},
medals: {
gold: 1,
silver: 3,
bronze: 0,
},
},
{
name: 'Libby Lenton-Trickett',
person: {
age: 23,
country: 'Australia',
},
medals: {
gold: 2,
silver: 1,
bronze: 1,
},
},
{
name: 'Ryan Lochte',
person: {
age: 24,
country: 'United States',
},
medals: {
gold: 2,
silver: 0,
bronze: 2,
},
},
{
name: 'Inge de Bruijn',
person: {
age: 30,
country: 'Netherlands',
},
medals: {
gold: 1,
silver: 1,
bronze: 2,
},
},
];
return rowData;
}
Field Copy Link
The Column Definition field property maps values from the row data object to the Column's Cells.
The field supports dot notation (e.g. medals.gold) to access properties of complex objects.
<ag-grid-vue
:rowData="rowData"
:columnDefs="columnDefs"
/* other grid options ... */>
</ag-grid-vue>
this.rowData = [
{
athlete: 'Michael Phelps',
medals: {
gold: 8, silver: 1, bronze: 0
}
}
];
this.columnDefs = [
// simple field attribute
{ field: 'athlete' },
// using dot notation, a Header Name is usually needed
{ field: 'medals.gold', headerName: 'Gold' },
]; Value Getter Copy Link
A Value Getter is a function that gets called for each row to return the Cell Value for a Column. Typically column cell values are loaded using a field, and then a valueGetter is used when retrieving the value requires custom logic. Columns with Value Getters usually have manually provided Header Names as the grid cannot derive Header Names from Value Getters like it does with Fields.
As with other value callbacks, params.data may be undefined for group rows or rows whose data has not loaded, so a Value Getter that reads from data should handle this case. See TypeScript Generics for how typing callback params surfaces nullable values at compile time.
this.columnDefs = [
// achieves the same as using 'athlete' for the field
{ headerName: 'Athlete', valueGetter: p => p.data.athlete },
// using valueGetter to combine 3 values into 1
{ headerName: 'Total Medals', valueGetter: p => p.data.bronze + p.data.silver + p.data.gold }
];Function or expression. Gets the value from your data for display. |
All valueGetters must be pure functions. That means, given the same state of your data, it should consistently return the same result. This is important as the grid will only call your valueGetter once during a redraw, even though the value may be used multiple times. For example, the value will be used to display the cell value, however it can additionally be used to provide values to an aggregation function when grouping.
The example below demonstrates valueGetter. The following can be noted from the demo:
Columns A and B are simple columns using
fieldValue Getters are used in all subsequent columns as follows:
- Column 'ID #' prints the row number, taken from the Row Node.
- Column 'A+B' adds A and B.
- Column 'A * 1000' multiplies A by 1000.
- Column 'B * 137' multiplies B by 137.
- Column 'Chain' takes the value 'A+B' and works on it further, thus chaining value getters.
- Column 'Const' returns back the same value for each column.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
ValueGetterParams,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
function hashValueGetter(params: ValueGetterParams) {
return params.node ? Number(params.node.id) : null;
}
function abValueGetter(params: ValueGetterParams) {
return params.data.a + params.data.b;
}
function a1000ValueGetter(params: ValueGetterParams) {
return params.data.a * 1000;
}
function b137ValueGetter(params: ValueGetterParams) {
return params.data.b * 137;
}
function chainValueGetter(params: ValueGetterParams) {
return params.getValue("aPlusB") * 1000;
}
function constValueGetter() {
return 99999;
}
function createRowData() {
const rowData = [];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(i % 4),
b: Math.floor(i % 7),
});
}
return rowData;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{
headerName: "ID #",
maxWidth: 100,
valueGetter: hashValueGetter,
},
{ field: "a" },
{ field: "b" },
{
headerName: "A + B",
colId: "aPlusB",
valueGetter: abValueGetter,
},
{
headerName: "A * 1000",
minWidth: 95,
valueGetter: a1000ValueGetter,
},
{
headerName: "B * 137",
minWidth: 90,
valueGetter: b137ValueGetter,
},
{
headerName: "Chain",
valueGetter: chainValueGetter,
},
{
headerName: "Const",
minWidth: 85,
valueGetter: constValueGetter,
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 75,
// cellClass: 'number-cell'
});
const rowData = ref<any[] | null>(createRowData());
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.number-cell {
text-align: right;
}
Header Value Getters Copy Link
See the Column Header Value Getters for an example of using headerValueGetter.

Values are mapped into Cells using either field or valueGetter from the Column Definition.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div style="height: 100%; box-sizing: border-box">
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
/>
</div> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ headerName: "Name (field)", field: "name" },
// Using dot notation to access nested property
{ headerName: "Country (field & dot notation)", field: "person.country" },
// Show default header name
{
headerName: "Total Medals (valueGetter)",
valueGetter: (p) =>
p.data.medals.gold + p.data.medals.silver + p.data.medals.bronze,
},
];
defaultColDef: ColDef = {
flex: 1,
};
rowData: any[] | null = getData();
}
export function getData(): any[] {
const rowData = [
{
name: 'Michael Phelps',
person: {
age: 23,
country: 'United States',
},
medals: {
gold: 8,
silver: 0,
bronze: 0,
},
},
{
name: 'Michael Phelps',
person: {
age: 19,
country: 'United States',
},
medals: {
gold: 6,
silver: 0,
bronze: 2,
},
},
{
name: 'Michael Phelps',
person: {
age: 27,
country: 'United States',
},
medals: {
gold: 4,
silver: 2,
bronze: 0,
},
},
{
name: 'Natalie Coughlin',
person: {
age: 25,
country: 'United States',
},
medals: {
gold: 1,
silver: 2,
bronze: 3,
},
},
{
name: 'Aleksey Nemov',
person: {
age: 24,
country: 'Russia',
},
medals: {
gold: 2,
silver: 1,
bronze: 3,
},
},
{
name: 'Alicia Coutts',
person: {
age: 24,
country: 'Australia',
},
medals: {
gold: 1,
silver: 3,
bronze: 1,
},
},
{
name: 'Missy Franklin',
person: {
age: 17,
country: 'United States',
},
medals: {
gold: 4,
silver: 0,
bronze: 1,
},
},
{
name: 'Ryan Lochte',
person: {
age: 27,
country: 'United States',
},
medals: {
gold: 2,
silver: 2,
bronze: 1,
},
},
{
name: 'Allison Schmitt',
person: {
age: 22,
country: 'United States',
},
medals: {
gold: 3,
silver: 1,
bronze: 1,
},
},
{
name: 'Natalie Coughlin',
person: {
age: 21,
country: 'United States',
},
medals: {
gold: 2,
silver: 2,
bronze: 1,
},
},
{
name: 'Ian Thorpe',
person: {
age: 17,
country: 'Australia',
},
medals: {
gold: 3,
silver: 2,
bronze: 0,
},
},
{
name: 'Dara Torres',
person: {
age: 33,
country: 'United States',
},
medals: {
gold: 2,
silver: 0,
bronze: 3,
},
},
{
name: 'Cindy Klassen',
person: {
age: 26,
country: 'Canada',
},
medals: {
gold: 1,
silver: 2,
bronze: 2,
},
},
{
name: 'Nastia Liukin',
person: {
age: 18,
country: 'United States',
},
medals: {
gold: 1,
silver: 3,
bronze: 1,
},
},
{
name: 'Marit Bjørgen',
person: {
age: 29,
country: 'Norway',
},
medals: {
gold: 3,
silver: 1,
bronze: 1,
},
},
{
name: 'Sun Yang',
person: {
age: 20,
country: 'China',
},
medals: {
gold: 2,
silver: 1,
bronze: 1,
},
},
{
name: 'Kirsty Coventry',
person: {
age: 24,
country: 'Zimbabwe',
},
medals: {
gold: 1,
silver: 3,
bronze: 0,
},
},
{
name: 'Libby Lenton-Trickett',
person: {
age: 23,
country: 'Australia',
},
medals: {
gold: 2,
silver: 1,
bronze: 1,
},
},
{
name: 'Ryan Lochte',
person: {
age: 24,
country: 'United States',
},
medals: {
gold: 2,
silver: 0,
bronze: 2,
},
},
{
name: 'Inge de Bruijn',
person: {
age: 30,
country: 'Netherlands',
},
medals: {
gold: 1,
silver: 1,
bronze: 2,
},
},
];
return rowData;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Field Copy Link
The Column Definition field property maps values from the row data object to the Column's Cells.
The field supports dot notation (e.g. medals.gold) to access properties of complex objects.
<ag-grid-angular
[rowData]="rowData"
[columnDefs]="columnDefs"
/* other grid options ... */ />
this.rowData = [
{
athlete: 'Michael Phelps',
medals: {
gold: 8, silver: 1, bronze: 0
}
}
];
this.columnDefs = [
// simple field attribute
{ field: 'athlete' },
// using dot notation, a Header Name is usually needed
{ field: 'medals.gold', headerName: 'Gold' },
]; Value Getter Copy Link
A Value Getter is a function that gets called for each row to return the Cell Value for a Column. Typically column cell values are loaded using a field, and then a valueGetter is used when retrieving the value requires custom logic. Columns with Value Getters usually have manually provided Header Names as the grid cannot derive Header Names from Value Getters like it does with Fields.
As with other value callbacks, params.data may be undefined for group rows or rows whose data has not loaded, so a Value Getter that reads from data should handle this case. See TypeScript Generics for how typing callback params surfaces nullable values at compile time.
this.columnDefs = [
// achieves the same as using 'athlete' for the field
{ headerName: 'Athlete', valueGetter: p => p.data.athlete },
// using valueGetter to combine 3 values into 1
{ headerName: 'Total Medals', valueGetter: p => p.data.bronze + p.data.silver + p.data.gold }
];Function or expression. Gets the value from your data for display. |
All valueGetters must be pure functions. That means, given the same state of your data, it should consistently return the same result. This is important as the grid will only call your valueGetter once during a redraw, even though the value may be used multiple times. For example, the value will be used to display the cell value, however it can additionally be used to provide values to an aggregation function when grouping.
The example below demonstrates valueGetter. The following can be noted from the demo:
Columns A and B are simple columns using
fieldValue Getters are used in all subsequent columns as follows:
- Column 'ID #' prints the row number, taken from the Row Node.
- Column 'A+B' adds A and B.
- Column 'A * 1000' multiplies A by 1000.
- Column 'B * 137' multiplies B by 137.
- Column 'Chain' takes the value 'A+B' and works on it further, thus chaining value getters.
- Column 'Const' returns back the same value for each column.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
ValueGetterParams,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
headerName: "ID #",
maxWidth: 100,
valueGetter: hashValueGetter,
},
{ field: "a" },
{ field: "b" },
{
headerName: "A + B",
colId: "aPlusB",
valueGetter: abValueGetter,
},
{
headerName: "A * 1000",
minWidth: 95,
valueGetter: a1000ValueGetter,
},
{
headerName: "B * 137",
minWidth: 90,
valueGetter: b137ValueGetter,
},
{
headerName: "Chain",
valueGetter: chainValueGetter,
},
{
headerName: "Const",
minWidth: 85,
valueGetter: constValueGetter,
},
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 75,
// cellClass: 'number-cell'
};
rowData: any[] | null = createRowData();
}
function hashValueGetter(params: ValueGetterParams) {
return params.node ? Number(params.node.id) : null;
}
function abValueGetter(params: ValueGetterParams) {
return params.data.a + params.data.b;
}
function a1000ValueGetter(params: ValueGetterParams) {
return params.data.a * 1000;
}
function b137ValueGetter(params: ValueGetterParams) {
return params.data.b * 137;
}
function chainValueGetter(params: ValueGetterParams) {
return params.getValue("aPlusB") * 1000;
}
function constValueGetter() {
return 99999;
}
function createRowData() {
const rowData = [];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(i % 4),
b: Math.floor(i % 7),
});
}
return rowData;
}
.number-cell {
text-align: right;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Header Value Getters Copy Link
See the Column Header Value Getters for an example of using headerValueGetter.